﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using JYAG.ClassicPassiveView.UI.View;
using JYAG.ClassicPassiveView.UI.Task;

namespace JYAG.ClassicPassiveView.UI.Presenter
{
    public class LoginPresenter: ILoginPresenter
    {
        private ILoginView view;
        private ILoginTask task;

        public LoginPresenter(ILoginView view, ILoginTask task)
        {
            this.view = view;
            this.task = task;
            view.InitializePresenter += (sender, e) => this.Initialize();
        }

        public LoginPresenter(ILoginView view) :
            this(view, new DummyLoginTask())
        {
        }

        private void Initialize()
        {
            this.view.RememberUser = true;
        }

        //Public function so it is visible in the view.
        //Not what we want
        public void Login()
        {
            this.view.ErrorMessageVisible = false;
            string username = this.view.Username;
            string password = this.view.Password;

            try
            {
                bool succes = this.task.Login(username, password);
                if (succes == false)
                {
                    ShowErrorMessage("Login failed");                    
                }
            }
            catch (Exception e)
            {
                ShowErrorMessage(e.Message);                
            }
        }

        private void ShowErrorMessage(string message)
        {
            this.view.ErrorMessage = message;
            this.view.ErrorMessageVisible = true;
        }
    }
}
