﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using JYAG.ClassicPassiveView.UI.Presenter;
using JYAG.ClassicPassiveView.UI.View;

namespace JYAG.ClassicPassiveView.WebUI
{
    public partial class LoginForm : Page, ILoginView
    {
        private ILoginPresenter presenter;

        protected void Page_Load(object sender, EventArgs e)
        {
            this.presenter = new LoginPresenter(this);
            HookUpEvents();
            if (!IsPostBack)
            {
                InitPresenter();
            }
        }

        private void InitPresenter()
        {
            if (this.InitializePresenter != null)
            {
                this.InitializePresenter.Invoke(this, new EventArgs());
            }
        }

        private void HookUpEvents()
        {
            this.loginButton.Click += (sender, e) => this.presenter.Login();
        }

        #region ILoginView Members

        public string Username
        {
            get { return usernameTextBox.Text; }
        }

        public string Password
        {
            get { return passwordTextBox.Text; }
        }

        public bool RememberUser
        {
            get { return rememberMeCheckBox.Checked; }
            set { rememberMeCheckBox.Checked = value; }
        }

        public string ErrorMessage
        {
            set { errorMessageLabel.Text = value; }
        }

        public bool ErrorMessageVisible
        {
            set { errorMessageLabel.Visible = value; }
        }

        #endregion

        #region IView Members

        public event EventHandler InitializePresenter;

        #endregion
    }
}
