﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using JYAG.ClassicPassiveView.UI.Presenter;
using JYAG.ClassicPassiveView.UI.View;

namespace JYAG.ClassicPassiveView.WinUI
{
    public partial class LoginForm : Form, ILoginView
    {
        private ILoginPresenter presenter;

        public LoginForm()
        {
            InitializeComponent();
            this.presenter = new LoginPresenter(this);
            InitPresenter();
            HookUpEvents();
        }

        private void InitPresenter()
        {
            if (this.InitializePresenter != null)
            {
                this.InitializePresenter.Invoke(this, new EventArgs());
            }
        }

        private void HookUpEvents()
        {
            this.loginButton.Click += (sender, e) => this.presenter.Login();
        }

        #region ILoginView Members

        public string Username
        {
            get { return usernameTextBox.Text; }
        }

        public string Password
        {
            get { return passwordTextBox.Text; }
        }

        public bool RememberUser
        {
            get { return rememberMeCheckBox.Checked; }
            set { rememberMeCheckBox.Checked = value; }
        }

        public string ErrorMessage
        {
            set { errorMessageLabel.Text = value; }
        }

        public bool ErrorMessageVisible
        {
            set { errorMessageLabel.Visible = value; }
        }

        #endregion

        #region IView Members

        public event EventHandler InitializePresenter;

        #endregion
    }
}
