﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using JYAG.ControlModel.UI.Presenter;
using JYAG.ControlModel.UI.View;
using JYAG.ControlModel.Framework.Controls;

namespace JYAG.ControlModel.WebUI
{
    public partial class LoginForm : Page, ILoginView
    {
        LoginPresenter presenter;

        protected void Page_Load(object sender, EventArgs e)
        {
            this.presenter = new LoginPresenter(this);
            if (!IsPostBack)
            {
                InitPresenter();
            }
        }

        private void InitPresenter()
        {
            if (this.InitializePresenter != null)
            {
                this.InitializePresenter.Invoke(this, new EventArgs());
            }
        }

        #region ILoginView Members

        public ITextBox UsernameTextBox
        {
            get { return usernameTextBox; }
        }

        public ITextBox PasswordTextBox
        {
            get { return passwordTextBox; }
        }

        public ICheckBox RememberUserCheckBox
        {
            get { return rememberMeCheckBox; }
        }

        public ILabel ErrorMessageLabel
        {
            get { return errorMessageLabel; }
        }

        public IButton LogInButton
        {
            get { return loginButton; }
        }

        #endregion

        #region IView Members

        public event EventHandler InitializePresenter;

        #endregion
    }
}
