﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using JYAG.ControlModel.UI.Presenter;
using JYAG.ControlModel.Framework.Controls;
using JYAG.ControlModel.UI.View;

namespace JYAG.ControlModel.WinUI
{
    public partial class LoginForm : Form, ILoginView
    {
        LoginPresenter presenter;

        public LoginForm()
        {
            InitializeComponent();
            this.presenter = new LoginPresenter(this);
            InitPresenter();            
        }

        private void InitPresenter()
        {
            if (this.InitializePresenter != null)
            {
                this.InitializePresenter.Invoke(this, new EventArgs());
            }
        }

        #region ILoginView Members

        public ITextBox UsernameTextBox
        {
            get { return usernameTextBox; }
        }

        public ITextBox PasswordTextBox
        {
            get { return passwordTextBox; }
        }

        public ICheckBox RememberUserCheckBox
        {
            get { return rememberMeCheckBox; }
        }

        public ILabel ErrorMessageLabel
        {
            get { return errorMessageLabel; }
        }

        public IButton LogInButton
        {
            get { return loginButton; }
        }

        #endregion

        #region IView Members

        public event EventHandler InitializePresenter;

        #endregion
    }
}
